#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>   // fuer perror()
#include <stdlib.h>  // fuer exit()
#include <stdio.h>   // fuer printf()
#define true 1

int main () {
  char* source = "source.txt";
  char* target = "target.txt";
  char c;
  int retval;   // benutzen wir mit close()
  int fd1, fd2;

  fd1 = open (source, O_RDONLY);
  if (fd1==-1) {
    perror ("copy: while opening source file");
    printf ("errno = %d\n", errno);
    exit (-1);
  }

  fd2 = creat (target, S_IRUSR | S_IWUSR);
  if (fd2==-1) {
    perror ("copy: while opening target file");
    printf ("errno = %d\n", errno);
    exit (-1);
  }

  while ( true ) {
    retval = read (fd1, &c, 1);
    if (retval==0) break;  // EOF Eingabedatei, Schleife verlassen
    if (retval==-1) {
      perror ("copy: while reading from source file");
      printf ("errno = %d\n", errno);
      exit (-1);
    };

    retval = write (fd2, &c, 1);
    if (retval==-1) {
      perror ("copy: while writing to target file");
      printf ("errno = %d\n", errno);
      exit (-1);
    };
  };

  retval = close (fd1);
  if (retval==-1) {
    perror ("copy: while closing source file");
    printf ("errno = %d\n", errno);
    exit (-1);
  }

  retval = close (fd2);
  if (retval==-1) {
    perror ("copy: while closing source file");
    printf ("errno = %d\n", errno);
    exit (-1);
  }

  return 0;
};  
